/* Répondeur téléphonique de filtrage d'appels.
  Version 1.16 interruptions sur PC0 à PC5 (PCINT8 à PCINT13) sur bornes A0 à A5 (PC0 à PC5) NANO/328.
  tests AVEC  identification du N° appelant.
  Le programme utilise une carte Arduino Nano.
  Voir le schéma associé et le texte explicatif qui constitue aussi un mode d'emploi.

  les nombreux "Serial.println" et le moniteur de l'IDE permettent de visualiser toutes les commandes.
  Géry Szczepanski
  bbnbnbn octets environ. (suivant version IDE)
  Bien évidement des améliorations/modifications sont possibles, vous trouverez des erreurs.
  Merci de me les signaler. J'ai volontairement évité la classe string...    Mais ça fonctionne.
  J'ai mis un max de commentaires. Je sais que je ne suis pas une "lumière" en programmation.

  ATTENTION : (Testé pour Nano et non testé sur d'autres cartes)
 a) Pilote USB pour carte Nano équipée de CH340G pour le pour USB sur http://www.5v.ru/ch340g.htm
 b) fichier de librairie "SoftwareSerial.cpp" modifié grâce à CG (ligne 233 mise en commentaire)
  //233____________  (ISR(PCINT1_vect, ISR_ALIASOF(PCINT0_vect));

 Version 1.16 05/08/2017 : l'arrêt du message avant de couper l'alimentation n'est plus nécessaire ! il y avait bug
 suppression des 5 lignes correspondantes. Alimentation permanente du MC145447 mais gestion de PWRUP
  --------------------- Sous programmes ou fonctions ---------------------------

*/

#include <avr/sleep.h>
#include <avr/wdt.h>
#include <SoftwareSerial.h>    // ajout pour Nano d'un 2 ème port (#include <NewSoftSerial.h> ne fonctionne pas)
#include <EEPROM.h>            // Librairie pour le stockage de données en mémoire Eeprom interne

#define alimentation_modules 2 // PD2 = D2 = pin2 alimentation modules ISD1760, décodeur TDMF MT8870 et MC145447P
#define connecter_telephone 3  // PD3 = D3 = pin3
#define boucler 4              // PD4 = D4 = pin4
#define txPin  5               // PD5 = D5 = pin5
#define rxPin  6               // PD6 = D6 = pin6
#define surTable 7             // PD7 = D7 = pin6  switch pour tests sur table ( = pas de mise en sleeep = accès au menu)
#define ledPin 13              // PB5 = D13 = pin13 LED verte connectée
#define sonner A2              // PC2 = A2 = pin le 50Hz d'appel
#define retourAppel A3         // PC3 = A3 = pin le 500Hz retour d'appel pour l'appelant (440 théorique)
#define envoyer_message A4     // PC4 = A4 = pin
#define positionRelaisL A5     // PC5 = A5 = pin position réelle (effective) du relais L. sécutité  *** ajout

volatile unsigned int lectureNow  = 0;      // lecture sur le port des 5 entrées surveillées C/nano328
volatile boolean flagMatos = false;         // interruption matériel détectée sur A0 ou A1
volatile byte compteurT2 = 0;               // compteur interruption timer2
volatile byte delaiT2 = 0;                  // délai état 1 état 2  interruption timer2 (signal se sonnerie 1,6/3,2 sec)
SoftwareSerial mySerial = SoftwareSerial(rxPin, txPin); // initialisation mySerial SoftwareSerial, port série N°2

unsigned int clignot = 0;       // clignotement led verte pin 13
unsigned int nb_de_0;           //
unsigned int nb_de_1;           //
// unsigned int nb_de_a;           // mes tests
unsigned int nb_alternances_N;  //
boolean appel = false;          //
boolean en_ligne = false;       // état de la ligne décroché du téléphone (en conversation)
boolean raccroche = false;      // état raccroché
// boolean decroche = false;       // état décroché du téléphone ne sert plus
boolean blancID = false;        // true si N° tél identifié en liste blanche

unsigned long delaiStop;    // mesure de temporisation millis
unsigned long timeStart;    // mesure de temporisation millis
unsigned long temps1 = 0;   // mesure de temporisation millis pour des vérifications/tests
unsigned long temps2 = 0;   // mesure de temporisation millis pour des vérifications/tests
unsigned long temps3 = 0;   // mesure de temporisation millis pour des vérifications/tests

char inByte = 0;            // affichage commandes du clavier moniteur série ( chiffre 0 au départ char par la suite)
byte value = 0;             // affichage commandes du clavier moniteur série
boolean flag_Table = false; // sans mise en veille (sleep) autorise les commandes moniteur série dans Loop
char messageID[100] = "";   // identification de l'appelant (MC145447P)
char numTelephone[11] = ""; // un N° de tél pour/de la liste blanche ou reçu Call ID
byte rangMax = 16;          // rang maxi (1 à 16) dans la liste blanche (16 x 10 = 160 car)

//---------------------------

void setup() {
  wdt_disable();                    // conseillé même si WD non utilisé.
  delay(1000);                      // attendre un peu l'initialisation
  Serial.begin(9600);               // pour moniteur série port USB (RX sur pin PD0 et TX sur pin PD1 Nano)
  pinMode(rxPin, INPUT_PULLUP);     // Set pin mode to input for Software serial RX Pin
  pinMode(txPin, OUTPUT);           // Set pin mode to output for Software serial TX Pin
  mySerial.begin(1200);             // Pour UNO et NANO ajouter un port sérial. (Rx pour MC145447P)

  pinMode(ledPin, OUTPUT);                       // LED orange sur la carte pin 16 = D13 = PB5
  digitalWrite(ledPin, LOW);                     // D13 mise à 0
  pinMode(alimentation_modules, OUTPUT);         // commande alimentation module ISD1760, décodeur TDMF MT8870 et MC145447P
  digitalWrite(alimentation_modules, HIGH);      // D2 mis à 1 (= arrêt)
  pinMode(connecter_telephone, OUTPUT);          // D3 Commande du relais L
  pinMode(boucler, OUTPUT);                      // D4 Commande optocoupleur prise de ligne

  pinMode(txPin, OUTPUT);               // D5                    libre
  digitalWrite(txPin, LOW);             // D6 PD6/D6  mise à 0   libre
  pinMode(rxPin, INPUT_PULLUP);         // D6
  pinMode(surTable, INPUT_PULLUP);      // switch tests sur table = pas de mise en sleeep

  deconnecter_Tel_Ligne ();             // initialisation des flags et excitation du relais L
  raccroche = false;                    // ne sert que pour le moniteur série

  DDRB  &= B11100000;		   // pin D8 à D12/nano328  PB0 à PB4 en entrée sans modifier les autres.
  PORTB &= B11100000;      // PB0 à PB4 en entrée SANS pull up sans modifier les autres. ( finalement)

  DDRC |= B00011100;       // Port C (pin A0 et A1 + Reset en entrée.  A2 à A4 en sortie)  A5 = entrée
  PORTC |= B11100011;      // pull up actives (PC7 non sortie ? )   // PUD = 0 par défaut  A5 = pull up

  Serial.println(F("Demarrage V 1.16 (avec identificaion de l'appelant)"));  // Pas de (F( si problème ld.ese.

  menuPrincipal();         // affichage du menu
  Serial.println();        // une ligne vide

  //   initialisation des interruptions ext. par PCINT1
  cli();                   // Désactive les interruptions globales
  PCMSK1 |= B00000011;     // PCINT 8 et 9 autorisée càd PC0 et PC1 (pin A0 et A1)
  PCICR |= B010;           // groupe PCIE1 = 1 (PCINT 8 et 9)
  PCIFR |= B010;           // pour effacer le flag PCIF1 (ou PCIFR |= (1<<PCIF1); ou  bitSet(PCIFR,PCIF1);
  //   initialisation des interruptions timer 2
  TCCR2A &= 0b11110000;    // WGM20 = 0  WGM21 = 0
  TCCR2B = 0b00000111;     // Clock / 1024 soit 16µS et WGM22 = 0
  TIMSK2 = 0b00000001;     // Interruption locale autorisée par TOIE2
  sei();
} // fin du setup

//-----------------------------
/*
void paramWatchdog() {   // ne sert pas pour l'instant

  cli();             // interdire toutes les interruptions (doublon avec celui dans le S/P appelant)
  wdt_reset();       // par précaution raz compteur watchdog  (CG : wdt_reset(); = asm volatile ("wdr");)

  MCUSR &= ~(1 << WDRF);    // équiv MCUSR & B11110111  raz du flag "WatchDog Reset"

  // Pour changer WDE ou le diviseur, --> mettre WDCE et WDE à 1 (permet ensuite m.à j pd 4 cycles d'horloge).
  WDTCSR |= (1 << WDCE) | (1 << WDE); // WDCE=1 et WDE=1 obligatoires pour cette séquence
  //             maintenant on peut modifier le diviseur et WDE
  WDTCSR = _BV(WDIE) | (1 << WDP3) | (1 << WDP0);
  //             WDTCSR = B01100001
  //             WDIE=1, et implicitement WDE=0
  //             (donc pas de resetWD prévu, seul TimerWD)
  //             valeur du diviseur chien de garde pour 8 secondes
  // sei();      // la revalidation ttes les interruptions est faite après.
}
*/
//---------------------------

// Routine d'interruption timer2  (signal de sonnerie = 1,7 sec et silence = 3,3 sec théorique)
ISR(TIMER2_OVF_vect) {

  TCNT2 = 256 - 250;             // de 6 à 256 = 250 x 64 µS = 16 ms  (16MHz --> 0.0625 µS * 1024 --> 64µS)
  if (compteurT2++ > delaiT2) {  // 100 * 16 ms = 1600 ms
    if (delaiT2 == 100)  {
      delaiT2 = 200;             // 3,2 sec
    } else {
      delaiT2 = 100;             // 1,6 sec
    }
    compteurT2 = 0;
  }
}
//---------------------------

// routine interruptions extérieures
ISR(PCINT1_vect) {    // Fonction de traitement PCINT1 (1 pour le groupe correspondant au port C)
  // 2 posibilités d'interruption. PC0 et PC1 (pin A0/nano réception d'un appel et A1/nano décrochage du téléphone)

  delayMicroseconds(2000);                    // = 2 ms (est un maxi)   pourquoi ?
  lectureNow = PINC & B00000011 ;             // lecture du port C et élimination des 6 bits inutiles
  if (lectureNow != 3 || en_ligne == true) {  // l'un des 2 bits est à 0 ou raccrochage (retour à 1 du bit 1)
    flagMatos = true;                         // drapeau positionné pour traiter interruption
  }
}
// ===========================

void decrochage_appel_raccrochage() {  // détecter un décrochage ou sonnerie ou raccrochage du téléphone
  // sous programme de traitement des interruptions extérieures matériel. Sur PC0 et PC1 (pin A0/nano)
  // 3 possibilités : décrochage du combiné, réception d'un train de sonnerie, raccrochage du combiné.
  // Les mesures ci-dessous ne tiennent pas compte du temps de sortie de veille du processeur.
  // Temps de passage = 50 ms pour un raccrochage. 1er train de sonnerie FREE = 220 ms  = environ (200 à 300 théorique ?)
  // 2ème train de sonnerie = 1540 ms environ *** 1er inter-train = 2022 ms. autres = 3364 ms environ (à confirmer)
  // Au décrochage : attente globale mesurée = 40 ms environ, (correspond au Nb du while)
  // Raccrochage = 0 ms.  Si appel, temps de passage = 0 ms environ

  delay (50);                          // Non modifier. Détection décrochage (si relais L chuté notamment)
  if (en_ligne == false) {             // Si tél non décroché, 2 posibilités : appel ou décrochage
    //   en_ligne = false;                  // décrochage prioritaire
    raccroche = true;                  // ne sert que pour le moniteur série

    reception_train_de_sonnerie();     //  2 cas, tester réception d'un train de sonnerie et attend la fin
    if (en_ligne) {                    // et simultanément tester le décrochage du téléphone
      connecter_Tel_Ligne();           // connecter le téléphone à la ligne
      // delay (100);          // ?* délai sécurité après connexion de ligne, stabilisation des courants
    }

    if (digitalRead(positionRelaisL) == LOW) appel = false; // LOW=relais au repos, ne pas tenir compte de l'appel
    //                               Si relais L au repos, le téléphone sonne normalement, attendre le décrochage.
    if (appel) digitalWrite(alimentation_modules, LOW); // D2 mis à 0 (= mise en marche des modules ISD1760,
    //                            du décodeur TDMF MT8870 et du CI MC145447P (identification du N°)
    //  Serial.print("*");  // test
  } else {                                   // cas 3, si déjà en ligne, tester le raccrochage du téléphone
    nb_de_1 = 0;
    lectureNow = PINC & B00000010 ;          // lecture du portC, bit 1 (pin A1/nano)
    while (lectureNow == 2 && nb_de_1 < 5) {  // 50 ?*
      delayMicroseconds(1000);               // attendre 1 ms environ
      lectureNow = PINC & B00000010 ;        // lecture
      ++ nb_de_1;
    }
    if (nb_de_1 > 4) {                       //49 ?*  (?* = modif 05/07/2016 accélérer décrochage et raccrochage=
      deconnecter_Tel_Ligne ();          // raccrochage du tél.
    }
    //  Serial.print("**");     // test
  }

  // ====== pour des tests ===================
  Serial.print("\nflagMatos = "); Serial.println(flagMatos); // test
  Serial.print("les 0 : "); Serial.println(nb_de_0);
  Serial.print("les 1 : "); Serial.println(nb_de_1);
  //   Serial.print("les a : "); Serial.println(nb_de_a);
  Serial.print("Nb alternances : "); Serial.println(nb_alternances_N);
  Serial.print("decrochage : "); Serial.println(en_ligne);
  //Serial.print("en_ligne : "); Serial.println(en_ligne);
  Serial.print("raccrochage : "); Serial.println(raccroche); // ne sert que pour le moniteur série
  Serial.print("appel : ");  Serial.println(appel);
  //Serial.print("temps1 : "); Serial.println(temps1);
  //Serial.print("temps2 : "); Serial.println(temps2);
  //Serial.print("temps3 : "); Serial.println(temps3);
  //Serial.print("temps2 - temps1 en us = "); Serial.println(temps2 - temps1);
  // *** supprimé  raccroche = false;     // ne sert pas sauf pour mes tests et affichage moniteur
  //====== fin des tests=================

  delay(50);             // APRES UN CHANGEMENT DETAT DU RELAIS DELAI DE STABILISATION
  flagMatos = false;     // suppression du flag, prêt pour la suite logique
}
//=============

void reception_train_de_sonnerie() {  // réception d'un train de sonnerie (Compter les alternances 50 Hz)

  nb_alternances_N = 0;
  //             Nota à voir plus tard
  //             il n'y a pas d'intégration du 50Hz, pourrait être incompatible avec l'identification de l'appelant
  cli();                                       // équiv noInterrupts();  Désactivation des interruptions
  do {
    nb_de_0 = 0 ;
    do {
      lectureNow = PINC & B00000001 ;          // lecture du portC, bit 0 (pin A0/nano)
      ++ nb_de_0;
      delayMicroseconds(1000);                 // = 1 ms
    } while (lectureNow == 0 && nb_de_0 < 56); //  56, signal actif à 0, attente passage à 1

    test_decrochage();                         // voir si décrochage du téléphone. si oui abréger l'appel

    ++ nb_alternances_N;                       // attente maxi = 56 ms, (rappel 1/2 période = 10 ms)
    nb_de_1 = 0;
    do {
      lectureNow = PINC & B00000001 ;          // lecture du portC, bit 0 (pin A0/nano)
      ++ nb_de_1;
      delayMicroseconds(1000);                                // attendre = 1 ms
    } while (lectureNow == 1 && nb_de_1 < 56 && !en_ligne);   // signal d'appel à 1 repos, attente passage à 0

  } while ( nb_de_1 < 55 &&  nb_de_0 < 55 && !en_ligne);      // 55 attente fin du 50 Hz, retour au repos à 1 > 55 ms

  if (nb_de_1 == 56 && nb_alternances_N > 4  && !en_ligne) {  // = 56 si appel OK
    // (valeurs FREE nb_alternances_N 1er train = 6;  2ème train = 72/78) (en plus des délais qui précèdent)
    // sur un test de sonnerie via télécomande TV  nb_alternances_N = 248 soit 250 = 20 = 5 sec environ
    appel = true;
  } else {
    appel = false;
  }
  PCIFR |= B010;       // pour effacer le flag PCIF1 (ou PCIFR |= (1<<PCIF1); ou  bitSet(PCIFR,PCIF1);
  sei();               // revalider les interruptions ou équiv interrupts();
}
//========================

void test_decrochage() {  // et mise en ligne si OK

  int nb_de_d = 0;                           // Nb de tests pour détecter un décrochage dans un train 50Hz

  lectureNow = PINC & B00000010;             // lecture du portC, bit 1 (pin A1/nano)
  while (lectureNow == 0 && nb_de_d < 4) {   // temps de passage mini pour un test décrochage = 860 us
    delayMicroseconds(1000);                 // attendre = 1 ms environ
    lectureNow = PINC & B00000010;           // lecture
    ++ nb_de_d;
  }
  if (nb_de_d > 3 ) {
    en_ligne = true;                 // décrochage acté
    digitalWrite(sonner, LOW);       // stopper l'envoi 50Hz Pin A2 portC mise à 0.
    // Serial.print("connecte");         // test
  }
}
//==============

void attend_2eme_train() {      // de sonnerie

  recevoir_ID_appelant ();      // entre 1er et 2éme train de sonnerie, après phase A, le modem reçoit le N°
  Serial.print("blanc = "); Serial.println(blancID);  // test

  if (blancID == true) {        // si N° tél identifié en liste blanche
    //                           2 possibilités, attendre la fin de l'appel ou le décrochage
    blancID = false;            // Raz
    byte zz1 = 0;               // compteur de coups de sonnerie
    byte zz2 = 0;               // compteur de coups de sonnerie

    do {                        // comptage des sonneries et test de fin
      delaiStop = 4000;         // 4 sec maxi pour attendre une nouvelle sonnerie
      timeStart = millis();

      do {                      // attend train se sonnerie
        if (flagMatos) {
          decrochage_appel_raccrochage();  // compter les trains de sonnerie, tester si décrochage
          ++zz1;
          Serial.println("+1");
          Serial.println(en_ligne);
        }
      } while (!en_ligne && ((millis() - timeStart) < delaiStop));  // Attend
      if (zz1 != zz2) {         // sonnerie zz1 > zz2
        zz2 = zz1;              // il y a eu sonnerie, équilibrage des valeurs
        Serial.println(zz1);
      } else {
        zz2 = 250;              // 250 = indicateur d'arrêt de sonnerie
        Serial.println(zz2);
      }
    } while (!en_ligne && zz2 < 200);

    if (!en_ligne) deconnecter_Tel_Ligne ();  // réinitialisations et retour à la situation repos
    // et si en_ligne, l'état en conversation est maintenu normalement

    Serial.println(en_ligne);

  } else {                      // donc blancID = false
    appel = false;
    // temps2 = micros () ;     // mes tests = fin 1er train + 1321288 uS

    delaiStop = 3000;           // = 3 sec maxi pour attendre le 2ème train de sonnerie (inter train = 2000ms ?)
    timeStart = millis();

    do {                        // attend le 2ème train se sonnerie
    } while (!flagMatos && ((millis() - timeStart) < delaiStop));  // Attend 26 octets mini. flagmatos = début 2ème train

    // temps3 = micros () ;     // mes tests = temps2 + 473032 uS = attente 2ème train (inter train # 2000 ms)
    decrochage_appel_raccrochage(); // détecter un décrochage ou sonnerie ou raccrochage
    Serial.println(" fin 2eme train de sonnerie ou delai expire.");

    if (appel) {                // le 2ème train de sonnerie valide et terminé
      appel_2_recu();           // pour la suite : boucler la ligne, envoyer message d'accueil, attendre DTMF
    }
    // dans les autres cas c'est fini :
    if (!en_ligne) deconnecter_Tel_Ligne (); // Pas de 2ème train de sonnerie. Tout réinitialiser et retour sommeil
  }
}
//============================

void appel_2_recu() {  // 2ème train OK donc boucler la ligne, envoyer message d'accueil, attendre DTMF

  digitalWrite(boucler, HIGH); // Pin 4 mise à 1 = bouclage de la ligne sur le filtrage d'appels
  delay(100);
  flagMatos = false;           // le bouclage a provoqué une interruption parasite

  recevoir_dtmf();             // envoyer message d'accueil et décoder signal DTMF envoyé par l'appelant.

  if (value == 10) value = 0;  // transformation du 0Ah en 0.
  //                           Nota : chiffre 0 = 0Ah ou 10d;    * = 0Bh ou 11d;     # = 0Ch ou 12d

  if (value == 4 || value == 5) {  // 4 = pour Géry code correct. Tous les autres seront rejetés sans suite
    Serial.println("Code OK. La suite : faire sonner le poste tel. ...");
    sonner_telephone();        // et mettre en relation si décrochage du tél.
  }                            // pas de else   ou if (value == 3) sonnerie extérieure pour le chien ?

  flagMatos = false;           // prêt pour le décrochage ou raccrohage

  // Code DTMF non valide ou absent, c'est fini.
  if (!en_ligne) deconnecter_Tel_Ligne ();   //  retour au sommeil si pas de décrochage   "good bay"
}
//===================

void sonner_telephone() {     // faire sonner le téléphone et envoyer le signal de retour d'appel à l'appelant.
  // délai maxi limité à 1 minute.  Signal d'appel : 1,6sec silence 3,2sec

  timeStart = millis();       // lecture heure du départ
  delaiStop = 60000;          // 90 sec maxi pour sonner le téléphone
  compteurT2 = 0;             // démarrer immédiatement sur un temps de sonnerie et non un silence
  delaiT2 = 0;                // démarrer immédiatement sur un temps de sonnerie et non un silence
  byte ii = 0;                // Générateur clock 50 Hz pour sonner
  byte uu = 0;                // Générateur clock 50 Hz pour sonner

  do {
    if (delaiT2 == 100) {           // valeur 100 = durant délai d'envoi
      digitalWrite(ledPin, HIGH);
      digitalWrite(retourAppel, !digitalRead(retourAppel));  // signal de retour d'appel (500 Hz) pour l'appelant
      delayMicroseconds(1000);      // = 2 ms par période Pin A3 portC mise à 1.     (440 Hz théorique)

      if (ii < 10 && uu == 0) {     // Générateur clock 50 Hz pour sonner T = 20 ms
        digitalWrite(sonner, HIGH); // Pin A2 portC mise à 1 (durant 10 ms)
        ++ ii;
        if (ii == 10) {             // comper 10 * 1 ms (1000 us) = 10 ms à 1
          uu = 10;
        }
      } else {
        digitalWrite(sonner, LOW);  // Pin A2 portC mise à 0.
        -- uu;
        if (uu == 0) {              // comper 10 * 1 ms (1000 us) = 10 ms à 0 (durant 10 ms)
          ii = 0;
        }
      }

    } else {
      digitalWrite(ledPin, LOW);
      digitalWrite(retourAppel, LOW);   // Pin A3 portC mise à 0. Raz retour d'appel
      digitalWrite(sonner, LOW);        // Pin A2 portC mise à 0. Raz entre les trains de sonnerie
    }
    if (flagMatos) reception_train_de_sonnerie();      // détecter un décrochage du téléphone

  } while (!en_ligne && ((millis() - timeStart) < delaiStop)); // attendre le décrochage

  if (en_ligne) {
    connecter_Tel_Ligne();  // connecter le téléphone à la ligne
    delay (100);            // par mesure de sécurité après une connexion de ligne (délai inutile ? déjà inclus dans connecter)
  } else {
    deconnecter_Tel_Ligne ();                // réinitialisations générales
  }
  digitalWrite(ledPin, LOW);
}
//===================

void recevoir_dtmf() {      // envoyer message d'accueil, attendre et décoder DTMF envoyé par l'appelant.

  int nbCodes = 0;          // Compte le nombre de codes envoyés/reçus en une commande (ex. mot de passe)
  int nbMessages = 0;       // Compte le nombre de répétitions du message
  value = 0;
  timeStart = millis();     // lecture heure du départ
  delaiStop = 60000;        // 60 sec maxi pour écouter le message (2 fois si le message dure 30 sec)
  // nota : ne pas mettre délai trop long car le raccrochage de l'appelant n'est pas détectable.
  // Il faut attendre l'expiration du délai pour libérer la ligne. (pas d'inversion de batterie)

  delay(100);               // ajout 07/2017 car ratés aléatoires sur le déclenchement du message
  digitalWrite(envoyer_message, HIGH);   // Pin A4 portC mise à 1. Répétition automatique car maintenu.

  do {                                      // Cette boucle récupère le codes envoyés
    byte lecturePortB = PINB & B00011111 ;  // lecture globale port B, élimination des 3 bits inutiles
    if (lecturePortB > 15) {                // la lecture est validée (StD à 1)
      value = lecturePortB &= B00001111;    // éliminer le bit4 à 0
      //          Nota : chiffre 0 donne 0Ah;  * donne 0Bh;  # donne 0Ch;  A à C donnent 0Dh à 0Fh et D = 00h
      nbCodes ++ ;                          // compter Nb de codes autorisés
      do {
        lecturePortB = PINB & B00011111 ;
      } while (lecturePortB > 15 && (millis() - timeStart) < delaiStop); // attendre la fin du code reçu (StD à 0)
      Serial.print(value, HEX);             // pour test de réception plusieurs codes
    }

    if (flagMatos) reception_train_de_sonnerie();      // détecter un décrochage du téléphone
    //  ******* if (flagMatos) decrochage_appel_raccrochage();   // détecter un décrochage du téléphone
  } while ( nbCodes < 1 && (millis() - timeStart) < delaiStop && !en_ligne);  // un seul code autorisé

  digitalWrite(envoyer_message, LOW);       // Pin A4 portC mise à 0  fin d'envoi du message d'accueil en continu
  delay(50);                                // attendre
  digitalWrite(alimentation_modules, HIGH); // D2 mis à 1 (= arrêt des modules ISD1760 et décodeur TDMF MT8870)

  if (en_ligne) {
    connecter_Tel_Ligne();  // connecter le téléphone à la ligne
    delay (100);            // par mesure de sécurité après une connexion de ligne (délai inutile ? déjà inclus dans connecter)
  }

  if (value < 13 && value > 0 ) {           // codes 0Bh 0Ch 0Dh exclus
    Serial.println(" = Code saisi.");
  } else {
    Serial.println(" = Pas de code valide."); // si aucun code entré, ne rien faire. (retour dodo)
  }
  // flagMatos = false;              inutile ?           // prêt pour le décrochage ou raccrohage
}
//================

void connecter_Tel_Ligne () {   // connecter le téléphone décroché directement à la ligne

  raccroche = false;                  // ne sert que pour le moniteur série
  appel = false;                      // réinitialisations
  pinMode(connecter_telephone, LOW);  // Pin D3 mise à 0 désexciter le relais L
  digitalWrite(envoyer_message, LOW); // Pin A4 portC mise à 0.
  digitalWrite(retourAppel, LOW);     // Pin A3 portC mise à 0. Raz finale
  digitalWrite(sonner, LOW);          // Pin A2 portC mise à 0.
  delay(150);                  // temps de désexcitation du relais L (20ms) + une louche stabilisation des courants
  digitalWrite(alimentation_modules, HIGH);  // D2 mis à 1 (= arrêt des modules ISD1760, CI TDMF MT8870 et MC145447)
  digitalWrite(boucler, LOW);         // Pin D4 mise à 0 = débouclage ligne pour Nano
  flagMatos = false;                  // prêt pour le raccrochage
}
//================

void deconnecter_Tel_Ligne () {   // déconnecter le téléphone de la ligne, retour au repos

  raccroche = true;                          // ne sert que pour le moniteur série
  en_ligne = false;
  appel = false;                             // réinitialisations
  blancID = false;                           // initialisation
  digitalWrite(connecter_telephone, HIGH);   // Pin D3 mise à 1 = exciter le relais L
  digitalWrite(envoyer_message, LOW);        // Pin A4 portC mise à 0
  digitalWrite(retourAppel, LOW);            // Pin A3 portC mise à 0. Raz finale
  digitalWrite(sonner, LOW);                 // Pin A2 portC mise à 0.
  delay(40);                                 // temps d'excitation du relais L (10ms) + une louche stabilisation des courants
  digitalWrite(alimentation_modules, HIGH);  // D2 mis à 1 (= arrêt des modules ISD1760, CI TDMF MT8870 et MC145447)
  digitalWrite(boucler, LOW);                // Pin D4 mise à 0 = débouclage ligne pour Nano
  flagMatos = false;                         // prêt pour une future détection (interruption)
}
//===============

void recevoir_ID_appelant () {      // et connecter la ligne sur le téléphone immédiatement si identifiant OK

  uint8_t x = 0;
  delaiStop = 1300;                 // = 1,3 sec maxi pour attendre l'identifiant (inter train = 2000ms ?)

  memset(messageID, '\0', 100);     // Initialisation de la chaîne de caractères (string).
  // delay(20);   // avec 100 = des ratés de call ID.  Ne sert à rien
  while ( mySerial.available() > 0) mySerial.read(); // Purger. Initialisation du tampon d'entrée (input buffer).
  x = 0;
  timeStart = millis();

  do {                                // Cette boucle attend l'identifiant de l'appelant
    if (mySerial.available() != 0) {  // teste s'il y a des données disponibles dans le tampon.
      messageID[x] = mySerial.read();
      if ( x < 99) x++;               // empêcher de déborder  (x limité à 26 pour traiter uniquement le N° de tel)
    }
  } while (!flagMatos && x < 50 && (millis() - timeStart) < delaiStop);  // Attent 50 octets mini. flagmatos = début 2ème train
  //
  Serial.println(messageID);         // nota : le moniteur ajoute 0D devant les 0A
  // char messageID[100] = "12345678901234512345678966789456567890123450962626262";  // test
  // test (afficher réponse du MC145447) exemple : €&06191143x097366.... ect...
  // Le numéro de tél. commence en 15ème position. (x ci-dessus = 1 caractères non imprimable $0A)
  // exemple de messageID : 80 16 01 08   30 36 32 32 31 32 33 32   02 0A    30 37 38 31 3x 3x 3x 3x 3x 3x   B8 00
  //                               08=8 chif     22/06  à   12:32      0A=10 chif          N° tél

  for (byte i = 14; i < 24; ++i ) {      // class string numTelephone = messageID.substring(15,24);  // 10 chiffres
    numTelephone[i - 14] = messageID[i]; // extraire le N° de téléphone.
  }
  // Serial.print("Num appelant = "); Serial.println(numTelephone); //  inutile car numeroBlanc() affiche ensuite

  if (strlen(numTelephone) > 0) {        //  attention : si numTelephone = "" numeroBlanc() retoune 1

    if (numeroBlanc()) connecter_Tel_Ligne () ; // test du N° dans la liste blanche si OK connecter sans délai
  }
}
//--------------------------------------------

void loop() {    // de 1 à 7, pour mes tests de mise au point

  flag_Table = !digitalRead(surTable); // permet de lancer des commandes moniteur série ( = pas de mise en sleeep)
  if (Serial.available()) {            // attente d'un caractère envoyé par le PC via portx  (moniteur Serie Arduino)
    inByte = Serial.read();            // lecture du caractère reçu
    value = inByte;
    Serial.print(char (inByte));       // afficher la touche de commande
    //                                    Affich_val_en_hex_bin();         // option d'affichage
    if (inByte > 96 && inByte < 123) { // sur les minuscules
      inByte = inByte & B11011111;     // bit de poids 2 du quartet fort éliminé pour passer en majuscule
    }
    //    digitalWrite(ledPin, HIGH);  // LED verte allumée   ?? pourquoi faire ?? voir en dernier

    switch (inByte) {             // de 1 à 6, des tests durant la mise au point
      case '1':
        Serial.println(F(" Commande de bouclage pour le filtrage d'appels"));
        digitalWrite(boucler, HIGH);   // Pin 4 mise à 1
        digitalWrite(ledPin, HIGH);    // LED verte allumée
        delay(1000);
        digitalWrite(ledPin, LOW);     // LED verte éteinte
        break;
      //==================================================
      case '2':
        Serial.println(F(" Commande de debouclage filtrage d'appels"));
        digitalWrite(boucler, LOW);    // Pin 4 mise à 0
        digitalWrite(ledPin, HIGH);    // LED verte allumée
        delay(1000);
        digitalWrite(ledPin, LOW);     // LED verte éteinte
        break;
      //==================================================
      case '3':        //
        Serial.println(F(" Alimentation des modules ISD1760, TDMF MT8870 et ID MC147447")); //
        digitalWrite(alimentation_modules, LOW); // D2 mis à 0 (= marche)
        // et de plus,
        decrochage_appel_raccrochage(); // pour tester le S/P
        break;
      //==================================================
      case '4':        //
        Serial.println(F(" Arret des modules"));
        digitalWrite(alimentation_modules, HIGH); // D2 mis à 1 (= arrêt)
        //flag_Table = 0;
        break;
      //==================================================
      case '5':        // Attente d'une commande DTMF et afficher la touche
        Serial.println(F(" Bouclage et attente 60 sec maxi commande DTMF et affichage"));
        digitalWrite(boucler, HIGH);  // Pin 4 mise à 1
        delay(100);
        flagMatos = false;
        recevoir_dtmf();              // délai = xx secondes maxi pour des tests
        digitalWrite(boucler, LOW);   // Pin 4 mise à 0
        break;
      //==================================================
      case '6':        // des tests
        Serial.println(F(" Test liste blanche"));
        //recevoir_ID_appelant();
        //numeroBlanc();
        // Serial.println(F(" mesurer le temps de decrochage sonner telephone (test)"));
        // decrochage_appel_raccrochage();  // mesure du temps
        // sonner_telephone();
        // mesurerTension();
        Serial.print("flagMatoss = "); Serial.println(flagMatos); // test
        Serial.print("appel = " );     Serial.println(appel);     // test
        Serial.print("blancID = " );   Serial.println(blancID);   // test
        Serial.print("en_ligne = " );  Serial.println(en_ligne);  // test

        break;
      //==================================================
      case '7':        // test
        Serial.println(F(" Envoi du message d'accueil (d'abord alimenter)"));    //
        digitalWrite(envoyer_message, HIGH);      // Pin A4 portC mise à 1
        delay(100);                    // une impulsion = une seule fois. (à répetition si maintenu)
        digitalWrite(envoyer_message, LOW);      // Pin A4 portC mise à 0
        break;
      //================================================== recevoir_dtmf()
      case '8':        // saisir/mettre un N° tél dans la liste blanche
        Serial.println(F(" Voir/Modifier la liste blanche (maxi = 16 Num)"));    //
        lectureListeBlanche();
        Serial.println(F(" Saisir le rang et Num tel.  (rang +espace +10 chiffres)"));    //
        saisirNumTel();
        break;
      //==================================================
      case '9':        // saisir/mettre un N° tél dans la liste blanche
        Serial.println(F(" Effacer la liste blanche"));    //
        effacer_liste_blanche();
        lectureListeBlanche();  // relecture pour voir les modifications
        break;
      //==================================================
      case '0':        // effacer un N° tél dans la liste blanche
        Serial.println(F(" Effacer un Num tel. dans la liste blanche"));        //
        Serial.println(F(" voir choix 8 en mettant le n' tel = 0000000000 (10 zeros)"));    //
        break;
      //==================================================
      case 'M':       // Rappel affichage du menu moniteur série
        menuPrincipal();
        break;
      //==================================================

      default:
        Serial.print(inByte); Serial.println(("  Commande non reconnue"));
        break;
    }   // fin de switch inByte
    inByte = 0;                    // Raz de la variable
    purgerBufferRec();             // purger caractères frappés en trop ou durant un action
  }   // fin de if (Serial.available()

  if (clignot == 0) digitalWrite(ledPin, !digitalRead(ledPin)); // inversion d'allumage (0.6 sec environ)
  clignot++;

  if (!flag_Table && !flagMatos ) allerDormir(); // Fonction de sommeil Arduino appelée
  // Ici réveil. Début de traitement interruptions Arduino

  if (flagMatos) {
    decrochage_appel_raccrochage();         // détecter un décrochage ou sonnerie ou raccrochage
    //                temps1 = micros () ;  // mes tests, fin du 1er train
    if (appel) attend_2eme_train();         // détection identifiant de l'appelant, 2ème train de sonnerie et la suite ...
  }
}  // fin de loop

//======================================

void allerDormir() {             // retour au sommeil Arduino après INT matos ou INT timerWD

  Serial.println(F("Mise en veille **************"));
  delay(100);                           // délai d'écriture
  digitalWrite(ledPin, LOW);            // extintion LED pin 13
  set_sleep_mode(SLEEP_MODE_PWR_DOWN);  // sleep mode is set here
  cli();                // équiv noInterrupts();  Désactivation des interruptions WD notamment
  sleep_enable();       // enables the sleep bit in the mcucr register
  sleep_bod_disable();
  // Remise en service des interruptions
  PCICR |= B010;        // groupe PCIE1 = 1 (PCINT 8 à 13)
  PCIFR |= B010;        // pour effacer le flag PCIF1 (ou PCIFR |= (1<<PCIF1); ou  bitSet(PCIFR,PCIF1);

  sei();                // ou interrupts();   // = sei autorise toutes les interruptions
  sleep_cpu();          // inter prise durant comptage sec. Mode veille activé Arduino  (ou sleep_mode() ?)

  // ************************** à partir D'ICI VEILLE - mode SLEEP ****************************

  sleep_disable();      // première chose après le réveil : sleep disable

  Serial.println(F("\nSortie de veille"));
  delay(50);           // 50 maxi Délai au réveil
} // fin de allerDormir

//------------------------------------------------------------------------

void menuPrincipal() {

  Serial.print(F(" --- Rappel des commandes clavier ---"));
  Serial.println(F(" ( Menu non accessible en veille)"));
  Serial.println(F(" 1 : Decrocher (bouclage ligne)"));
  Serial.println(F(" 2 : Raccrocher (debouclage ligne)"));
  Serial.println(F(" 3 : Alimenter des modules ISD1760, TDMF MT8870 et ID MC147447"));
  Serial.println(F(" 4 : Arreter des modules"));
  Serial.println(F(" 5 : Recevoir et afficher code DTMF"));
  Serial.println(F(" 6 : Test liste blanche"));
  Serial.println(F(" 7 : Envoyer message d'accueil (d'abord alimenter)"));
  Serial.println(F(" 8 : Voir/Modifier la liste blanche")); // en EEprom
  Serial.println(F(" 9 : Effacer la liste blanche"));
  Serial.println(F(" 0 : Effacer un N' tel. dans la liste blanche"));
  /*
        Serial.println(F(" t ou T : Mesure tension batterie"));
      */
  Serial.println(F(" m ou M : Rappel du menu"));
}
//============================

void Affich_val_en_hex_bin() {  // option en utilisant le clavier et port série USB pour tests.

  char binaire[6] = "";
  Serial.print("\t : ");             // tabulation : multiple de 8 caractères
  // Serial.print(value, HEX);       // value en hexa  - NB: les  zéros de poids fort ne sont pas transcrits
  // Serial.print("\t : ");
  // Serial.println(value, BIN);     // value en binaire - NB: les  zéros de poids fort ne sont pas transcrits

  for ( byte i = 0; i <= 4; ++i ) {  // 5 bits à afficher
    if (bitRead(value, 4 - i)) {
      binaire[i] = '1';
    } else  {
      binaire[i] = '0';
    }
  }
  Serial.println(binaire);          // affichage en binaire y compris 0 le 5 ème (à gauche car bit 0 à droite)
}
//============================================

void purgerBufferRec() {           // purger sinon caractères frappés durant l'attente pris en compte.

  do {
    Serial.read();
    delay (5);
  } while (Serial.available() > 0 ); // on purge
}
//============== FIN ==============

void saisirNumTel() {    // saisie d'un N° de téléphone au clavier : rang(1 à 16) + espace + 10 chiffres

  byte valideur = true;             // reste à true en sortie si OK    (compromis pour accepter HyperTerminal Windows)
  char aux_string [14] = "";        // buffer chaîne de caractères entrés au clavier (rang = (1 ou 2 chiffres))
  char aux_rang [3] = "";           // buffer rang dans la liste
  char carLu = 0;                   // variable contenant le caractère lu
  byte x = 0 ;                      // rang du caractère entré au clavier
  timeStart = millis();             // mesure heure du départ
  delaiStop = 20000;                // 20 sec maxi d'attente pour saisir les chiffres et taper "Entrée". (et pour éviter la boucle sans fin)

  purgerBufferRec();                // au cas où resteraient des caractères NL ou CR notamment
  while (Serial.available() == 0 && (millis() - timeStart) < delaiStop); // on attend la réponse validée par "Entrée" (limité à 20 sec)
  timeStart = millis();              // lecture heure du départ
  delaiStop = 2500;                  // 2,5 sec autorisé entre chaque chiffre. Utile si envoi chiffre par chiffre avec Terminal Windows
  do {                               // Cette boucle récupère les données du clavier
    if (Serial.available() > 0) {    // si caractères reçus
      delay (5);
      carLu =  Serial.read();
      if (((carLu > 47 && carLu < 58) || carLu == 32) &&  x < 13 ) {  // filtrage, n'accepter que espace et des chiffres.
        aux_string[x] = carLu;       // rangement dans char[x], en position x (10 chiffres maxi)
      } else {                       // si des caractères NL ou CR sont ajoutés = erreur de saisie
        valideur = false;
      }
      x++;                           // incrémentation pour le futur chiffre
      timeStart = millis();          // relecture heure du départ, donne 2,5 sec entre chaque chiffre
    }
  } while (((millis() - timeStart) < delaiStop)); // 2,5 sec maxi entre 2 chiffres avec terminal Windows
  aux_string[x] = '\0';                         // marquer la fin de chaîne.

  byte j = 0;
  for ( int i = 2; i < x + 1 ; ++i ) {      // y compris fin de chaîne (x = 10)
    if (aux_string[i] != 32) {              // ne pas prendre l'espace
      numTelephone[j] = aux_string[i];  // affectation de la valeur à la variable numTelephone
      ++j;
    }
  }

  if (j != 11) valideur = false;      // j = 11, c'est un N° de tél. 10 chiffres
  j = 0;
  for ( int i = 0; i < 2 ; ++i ) {    // y compris fin de chaîne
    if (aux_string[i] != 32) {        // ne pas prendre l'espace
      aux_rang[j] = aux_string[i];    // affectation de la valeur à la variable rang
      ++j;
    }
  }
  aux_rang[j] = '\0';                 // marquer la fin de chaîne.
  byte rang = atoi(aux_rang);         // convertir en string en nombre

  /*  mes tests
    Serial.println(j);                   // vérification du Nb de caractères. Test
    Serial.println(valideur);            // vérification du valideur. Test
    Serial.println(numTelephone);    // vérification du Num. Test
    Serial.println(rang);                // vérification du rang Test
  */

  j = 0;   // tester pour identifier une demande d'effacement (num tél = 0000000000)
  for ( int i = 0; i < 10 ; ++i ) {         //
    if (numTelephone[i] == 48 )  ++j;       // 48d = chiffre 0
  }
  if (j == 10) {        //
    for ( int i = 0; i < 10 ; ++i ) {      //
      numTelephone[i] = 32 ;               // FFh = 255d = 'ÿ' ou mettre 32d = espace
    }
  }

  if (rang > 0 && rang < rangMax + 1 && valideur) { // rang = 1 à 16 autorisés.
    ecrireEEprom(rang, valideur);
  } else {
    Serial.println(("Erreur de saisie ou vide! Recommencer.\nAttention : avec le moniteur Arduino, pas de fin de ligne"));
  }
}
//=============================

void ecrireEEprom(byte rang, boolean valideur) {  // ecrire en liste blanche, en EEprom,

  byte yy = 0;
  byte i = 0;
  byte delta = (rang - 1) * 10;    //  calcul de l'adresse de départ pour écrire (10 octets par N° sans séparateur)

  delay (10);
  for ( i = 0 ; i < 10 ; ++i ) {              // écriture en Eeprom 10 octets
    EEPROM.write(delta + i, numTelephone[i]); // écrit une valeur en mémoire Eeprom à l'adresse delta
    //         Serial.print(numTelephone[i]); // test
    delay (10);
  }
  if (valideur) lectureListeBlanche();        // relecture pour voir les modifications
}
//=============================

void effacer_liste_blanche() {        // totalement

  boolean effacer = false;            // return true si confirmation

  if (demanderConfirmation(effacer)) {
    byte i = 0;
    delay (10);
    for ( i = 0 ; i < 161 ; ++i ) {   // écriture en Eeprom  10 x 16 N° = 160 caractères
      EEPROM.write( i, 255);          // écrit FFh en mémoire EEprom à l'adresse i
      delay (10);
    }
    Serial.println((" OK effacement \n"));    //
  }
}
//=============================

void lectureListeBlanche() {  // en EEprom, départ = 00

  byte yy = 0;
  byte i = 0;
  byte rang = 1;

  Serial.println(F("\n Affichage/Modification de la liste blanche (qui doit etre continue)\n vierge = effacee/libre"));
  Serial.print(" Rang");
  Serial.println(F("\t : Num tel (10 chiffres) "));
  do {
    byte j = 0;
    memset(numTelephone, '\0', 11);      // raz texteSMSmanu, on repart d'une situation propre
    for ( i = (rang - 1) * 10; i < (rang * 10); ++i ) { // 10 caract. non compris fin de string Nul ( N° tél)
      yy = EEPROM.read(i);
      numTelephone[j] = yy;              // N° tél
      ++j;
    }
    if (strlen(numTelephone) != 10) memset(numTelephone, '\0', 11);   //

    Serial.print("  "); Serial.print(rang);  Serial.print("\t : ");  Serial.println(numTelephone);
    ++ rang;
  } while (yy != 255 && rang < rangMax + 1);        // 10 x 16 N° = 160 caractères
  Serial.print((" dernier rang disponible = ")); Serial.println(rang - 1 );
}
//===================

boolean numeroBlanc() { // voir si le numéro de tél appartient à la liste blanche. Si oui: sonner immédiatement.

  byte yy = 0;
  byte i = 0;
  blancID = false;                    // return true si N° tél identifié en liste blanche
  char listeBlanche[162] = {'\0'};    // 162 = un de plus que nécessaire

  //1 charger la liste blanche
  for ( i = 0; i < 162; ++i ) {       // 10 chiffres /  N° tél
    yy = EEPROM.read(i);
    listeBlanche[i] = yy;             // N° tél
    //  Serial.print(yy, HEX);        // test
  }
  String texte1 = (listeBlanche);     // conversion char en string

  //2 charger le N° de l'appelant dans messageID
  //    char numTelephone[11] = "1234567890";  // test
  String texte2 = (numTelephone);     // conversion char en string
  Serial.println(numTelephone);       // test     attention : si numTelephone = "", return = true = 1

  //3 tester la présence ou non du N°
  int laPosition = texte1.indexOf(texte2); // Le N° est-il dans la liste blanche ?  (si non = -1)

  if (laPosition > -1) blancID = true;
  Serial.println(laPosition);         // test

  return (blancID);
}
//===================

boolean demanderConfirmation(boolean effacer) {        // pour effacer la liste blanche

  Serial.print(F("\n Effacement total de la liste blanche ? \n confirmer O ou N  "));
  timeStart = millis();            // mesure heure du départ
  delaiStop = 5000;                // 5 sec maxi d'attente
  inByte = 0;
  char carLu = 0;                  // caractère lu

  while (Serial.available() == 0 && (millis() - timeStart) < delaiStop); // on attend réponse
  if (Serial.available() > 0) {                       // si caractère reçu
    delay (5);
    carLu =  Serial.read();
    Serial.println(carLu);                            // afficher la réponse
    if (carLu == 79 || carLu == 111) effacer = true;  // 79 = "O" ou 111 = "o"
  }
  return (effacer);
}
//========================ci-dessous ne sert pas ===========================================

/*
void mesurerTension() {          // mesure de la tension pin AUX du ISD1760 (1,3 V = si message en cours)
  //                                Ne devait plus servir avec Marche/Arret des modules.
  int unsigned mesureValue = 0;  // Valeur lue (quantification)
  int unsigned sommeTensions = 0;

  for ( int i = 0; i < 5 ;  ++i ) {
    mesureValue = analogRead(mesureAnaPin);    // pin à mesurer A7/nano328 (conversion 10 bits)
    sommeTensions = sommeTensions + mesureValue;
    delay (5);         //
  }
  // calcul de la tension (diviser par 5 pour moyenne sur 5 lectures)
  tension_V = ((sommeTensions * 5.0 / 1024.0) / 5.0 );       // tension de référence = 5,0 V
  // Serial.print("tension = "); Serial.println(tension_V);  // pour mes tests uniquement
  // delay (100);
}
*/
//===================

